/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Diff of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.159 Revision 1.301
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2015 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.159 2006/02/17 22:18:20 swegener Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.301 2015/03/20 00:13:32 mpagano Exp $
4 4
5# Description: kernel.eclass rewrite for a clean base regarding the 2.6 5# Description: kernel.eclass rewrite for a clean base regarding the 2.6
6# series of kernel with back-compatibility for 2.4 6# series of kernel with back-compatibility for 2.4
7# 7#
8# Maintainer: John Mylchreest <johnm@gentoo.org> 8# Original author: John Mylchreest <johnm@gentoo.org>
9# Maintainer: kernel-misc@gentoo.org
9# 10#
10# Please direct your bugs to the current eclass maintainer :) 11# Please direct your bugs to the current eclass maintainer :)
11 12
12# added functionality: 13# added functionality:
13# unipatch - a flexible, singular method to extract, add and remove patches. 14# unipatch - a flexible, singular method to extract, add and remove patches.
21# EXTRAVERSION would be something like : -wolk-4.19-r1 22# EXTRAVERSION would be something like : -wolk-4.19-r1
22# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be 23# K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
23# automatically set within the kernel Makefile 24# automatically set within the kernel Makefile
24# K_NOUSENAME - if this is set then EXTRAVERSION will not include the 25# K_NOUSENAME - if this is set then EXTRAVERSION will not include the
25# first part of ${PN} in EXTRAVERSION 26# first part of ${PN} in EXTRAVERSION
27# K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28# anything based on ${PR}.
26# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources, 29# K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
27# ck-sources, ac-sources) it will use PR (ie: -r5) as 30# ck-sources, ac-sources) it will use PR (ie: -r5) as
28# the patchset version for 31# the patchset version for
29# and not use it as a true package revision 32# and not use it as a true package revision
30# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in 33# K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
31# postinst and can be used to carry additional postinst 34# postinst and can be used to carry additional postinst
32# messages 35# messages
36# K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
33# K_EXTRAEWARN - same as K_EXTRAEINFO except ewarn's instead of einfo's 37# K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
34# K_SYMLINK - if this is set, then forcably create symlink anyway 38# K_SYMLINK - if this is set, then forcably create symlink anyway
35# 39#
36# K_DEFCONFIG - Allow specifying a different defconfig target. 40# K_DEFCONFIG - Allow specifying a different defconfig target.
37# If length zero, defaults to "defconfig". 41# If length zero, defaults to "defconfig".
38# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any 42# K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
39# combination of "base" and "extras" 43# combination of "base", "extras" or "experimental".
44# K_EXP_GENPATCHES_PULL - If set, we pull "experimental" regardless of the USE FLAG
45# but expect the ebuild maintainer to use K_EXP_GENPATCHES_LIST.
46# K_EXP_GENPATCHES_NOUSE - If set, no USE flag will be provided for "experimental";
47# as a result the user cannot choose to apply those patches.
48# K_EXP_GENPATCHES_LIST - A list of patches to pick from "experimental" to apply when
49# the USE flag is unset and K_EXP_GENPATCHES_PULL is set.
40# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply. 50# K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
41# A value of "5" would apply genpatches-2.6.12-5 to 51# A value of "5" would apply genpatches-2.6.12-5 to
42# my-sources-2.6.12.ebuild 52# my-sources-2.6.12.ebuild
43 53# K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
54# K_DEBLOB_AVAILABLE - A value of "0" will disable all of the optional deblob
55# code. If empty, will be set to "1" if deblobbing is
56# possible. Test ONLY for "1".
57# K_PREDEBLOBBED - This kernel was already deblobbed elsewhere.
58# If false, either optional deblobbing will be available
59# or the license will note the inclusion of freedist
60# code.
61# K_LONGTERM - If set, the eclass will search for the kernel source
62# in the long term directories on the upstream servers
63# as the location has been changed by upstream
44# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which 64# H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
45# can be supported by the headers ebuild 65# can be supported by the headers ebuild
46 66
47# UNIPATCH_LIST - space delimetered list of patches to be applied to the 67# UNIPATCH_LIST - space delimetered list of patches to be applied to the
48# kernel 68# kernel
53# UNIPATCH_DOCS - space delimemeted list of docs to be installed to 73# UNIPATCH_DOCS - space delimemeted list of docs to be installed to
54# the doc dir 74# the doc dir
55# UNIPATCH_STRICTORDER - if this is set places patches into directories of 75# UNIPATCH_STRICTORDER - if this is set places patches into directories of
56# order, so they are applied in the order passed 76# order, so they are applied in the order passed
57 77
78# Changing any other variable in this eclass is not supported; you can request
79# for additional variables to be added by contacting the current maintainer.
80# If you do change them, there is a chance that we will not fix resulting bugs;
81# that of course does not mean we're not willing to help.
82
83PYTHON_COMPAT=( python{2_6,2_7} )
84
58inherit toolchain-funcs versionator multilib 85inherit eutils toolchain-funcs versionator multilib python-any-r1
59EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install \ 86EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm
60 pkg_preinst pkg_postinst
61 87
62# Added by Daniel Ostrow <dostrow@gentoo.org> 88# Added by Daniel Ostrow <dostrow@gentoo.org>
63# This is an ugly hack to get around an issue with a 32-bit userland on ppc64. 89# This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
64# I will remove it when I come up with something more reasonable. 90# I will remove it when I come up with something more reasonable.
65[[ ${PROFILE_ARCH} == 'ppc64' ]] && CHOST='powerpc64-unknown-linux-gnu' 91[[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
66 92
67export CTARGET=${CTARGET:-${CHOST}} 93export CTARGET=${CTARGET:-${CHOST}}
68if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then 94if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
69 export CTARGET=${CATEGORY/cross-} 95 export CTARGET=${CATEGORY/cross-}
70fi 96fi
71 97
72HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/" 98HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
73LICENSE="GPL-2" 99: ${LICENSE:="GPL-2"}
100
101# This is the latest KV_PATCH of the deblob tool available from the
102# libre-sources upstream. If you bump this, you MUST regenerate the Manifests
103# for ALL kernel-2 consumer packages where deblob is available.
104: ${DEBLOB_MAX_VERSION:=38}
105
106# No need to run scanelf/strip on kernel sources/headers (bug #134453).
107RESTRICT="binchecks strip"
74 108
75# set LINUX_HOSTCFLAGS if not already set 109# set LINUX_HOSTCFLAGS if not already set
76[[ -z ${LINUX_HOSTCFLAGS} ]] && \
77 LINUX_HOSTCFLAGS="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include" 110: ${LINUX_HOSTCFLAGS:="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"}
111
112# debugging functions
113#==============================================================
114# this function exists only to help debug kernel-2.eclass
115# if you are adding new functionality in, put a call to it
116# at the start of src_unpack, or during SRC_URI/dep generation.
117debug-print-kernel2-variables() {
118 for v in PVR CKV OKV KV KV_FULL KV_MAJOR KV_MINOR KV_PATCH RELEASETYPE \
119 RELEASE UNIPATCH_LIST_DEFAULT UNIPATCH_LIST_GENPATCHES \
120 UNIPATCH_LIST S KERNEL_URI K_WANT_GENPATCHES ; do
121 debug-print "${v}: ${!v}"
122 done
123}
78 124
79#Eclass functions only from here onwards ... 125#Eclass functions only from here onwards ...
80#============================================================== 126#==============================================================
81handle_genpatches() { 127handle_genpatches() {
82 local tarball 128 local tarball
83 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return -1 129 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
130
131 debug-print "Inside handle_genpatches"
132 local OKV_ARRAY
133 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
134
135 # for > 3.0 kernels, handle genpatches tarball name
136 # genpatches for 3.0 and 3.0.1 might be named
137 # genpatches-3.0-1.base.tar.xz and genpatches-3.0-2.base.tar.xz
138 # respectively. Handle this.
84 139
85 for i in ${K_WANT_GENPATCHES} ; do 140 for i in ${K_WANT_GENPATCHES} ; do
141 if [[ ${KV_MAJOR} -ge 3 ]]; then
142 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
143 tarball="genpatches-${KV_MAJOR}.${KV_MINOR}-${K_GENPATCHES_VER}.${i}.tar.xz"
144 else
145 tarball="genpatches-${KV_MAJOR}.${KV_PATCH}-${K_GENPATCHES_VER}.${i}.tar.xz"
146 fi
147 else
86 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.bz2" 148 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.xz"
87 GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}" 149 fi
150
151 local use_cond_start="" use_cond_end=""
152
153 if [[ "${i}" == "experimental" && -z ${K_EXP_GENPATCHES_PULL} && -z ${K_EXP_GENPATCHES_NOUSE} ]] ; then
154 use_cond_start="experimental? ( "
155 use_cond_end=" )"
156
157 if use experimental ; then
158 UNIPATCH_LIST_GENPATCHES+=" ${DISTDIR}/${tarball}"
159 debug-print "genpatches tarball: $tarball"
160 fi
161 else
88 UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}" 162 UNIPATCH_LIST_GENPATCHES+=" ${DISTDIR}/${tarball}"
163 debug-print "genpatches tarball: $tarball"
164 fi
165 GENPATCHES_URI+=" ${use_cond_start}mirror://gentoo/${tarball}${use_cond_end}"
89 done 166 done
90} 167}
91 168
92detect_version() { 169detect_version() {
93 # this function will detect and set 170 # this function will detect and set
94 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11) 171 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
95 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1) 172 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
96 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1) 173 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
97 174
98 if [[ -n ${KV_FULL} ]]; then 175 # We've already run, so nothing to do here.
99 # we will set this for backwards compatibility. 176 [[ -n ${KV_FULL} ]] && return 0
100 KV=${KV_FULL}
101
102 # we know KV_FULL so lets stop here. but not without resetting S
103 S=${WORKDIR}/linux-${KV_FULL}
104 return
105 fi
106 177
107 # CKV is used as a comparison kernel version, which is used when 178 # CKV is used as a comparison kernel version, which is used when
108 # PV doesnt reflect the genuine kernel version. 179 # PV doesnt reflect the genuine kernel version.
109 # this gets set to the portage style versioning. ie: 180 # this gets set to the portage style versioning. ie:
110 # CKV=2.6.11_rc4 181 # CKV=2.6.11_rc4
114 OKV=${OKV/_rc/-rc} 185 OKV=${OKV/_rc/-rc}
115 OKV=${OKV/-r*} 186 OKV=${OKV/-r*}
116 OKV=${OKV/_p*} 187 OKV=${OKV/_p*}
117 188
118 KV_MAJOR=$(get_version_component_range 1 ${OKV}) 189 KV_MAJOR=$(get_version_component_range 1 ${OKV})
190 # handle if OKV is X.Y or X.Y.Z (e.g. 3.0 or 3.0.1)
191 local OKV_ARRAY
192 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
193
194 # if KV_MAJOR >= 3, then we have no more KV_MINOR
195 #if [[ ${KV_MAJOR} -lt 3 ]]; then
196 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
119 KV_MINOR=$(get_version_component_range 2 ${OKV}) 197 KV_MINOR=$(get_version_component_range 2 ${OKV})
120 KV_PATCH=$(get_version_component_range 3 ${OKV}) 198 KV_PATCH=$(get_version_component_range 3 ${OKV})
121
122 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then 199 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
200 KV_EXTRA=$(get_version_component_range 4- ${OKV})
201 KV_EXTRA=${KV_EXTRA/[-_]*}
202 else
203 KV_PATCH=$(get_version_component_range 3- ${OKV})
204 fi
205 else
206 KV_PATCH=$(get_version_component_range 2 ${OKV})
123 KV_EXTRA=$(get_version_component_range 4- ${OKV}) 207 KV_EXTRA=$(get_version_component_range 3- ${OKV})
124 KV_EXTRA=${KV_EXTRA/[-_]*} 208 KV_EXTRA=${KV_EXTRA/[-_]*}
209 fi
210
211 debug-print "KV_EXTRA is ${KV_EXTRA}"
212
213 KV_PATCH=${KV_PATCH/[-_]*}
214
215 local v n=0 missing
216 #if [[ ${KV_MAJOR} -lt 3 ]]; then
217 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
218 for v in CKV OKV KV_{MAJOR,MINOR,PATCH} ; do
219 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
220 done
125 else 221 else
126 KV_PATCH=$(get_version_component_range 3- ${OKV}) 222 for v in CKV OKV KV_{MAJOR,PATCH} ; do
223 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
224 done
225 fi
226
227 [[ $n -eq 1 ]] && \
228 eerror "Missing variables: ${missing}" && \
229 die "Failed to extract kernel version (try explicit CKV in ebuild)!"
230 unset v n missing
231
232# if [[ ${KV_MAJOR} -ge 3 ]]; then
233 if [[ ${#OKV_ARRAY[@]} -lt 3 ]]; then
234 KV_PATCH_ARR=(${KV_PATCH//\./ })
235
236 # at this point 031412, Linus is putting all 3.x kernels in a
237 # 3.x directory, may need to revisit when 4.x is released
238 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
239
240 [[ -n "${K_LONGTERM}" ]] &&
241 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_PATCH_ARR}"
242 else
243 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.0"
244 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
245 if [[ ${KV_MAJOR} -ge 3 ]]; then
246 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
247 else
248 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
127 fi 249 fi
128 KV_PATCH=${KV_PATCH/[-_]*}
129 250
130 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 251 [[ -n "${K_LONGTERM}" ]] &&
252 #KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm"
253 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
254 fi
255
256 debug-print "KERNEL_BASE_URI is ${KERNEL_BASE_URI}"
257
258 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
259 # handle non genpatch using sources correctly
260 if [[ -z ${K_WANT_GENPATCHES} && -z ${K_GENPATCHES_VER} && ${KV_PATCH} -gt 0 ]]; then
261 KERNEL_URI="${KERNEL_BASE_URI}/patch-${OKV}.xz"
262 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
263 fi
264 KERNEL_URI="${KERNEL_URI} ${KERNEL_BASE_URI}/linux-${KV_MAJOR}.${KV_MINOR}.tar.xz"
265 else
266 KERNEL_URI="${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
267 fi
131 268
132 RELEASE=${CKV/${OKV}} 269 RELEASE=${CKV/${OKV}}
133 RELEASE=${RELEASE/_beta} 270 RELEASE=${RELEASE/_beta}
134 RELEASE=${RELEASE/_rc/-rc} 271 RELEASE=${RELEASE/_rc/-rc}
135 RELEASE=${RELEASE/_pre/-pre} 272 RELEASE=${RELEASE/_pre/-pre}
273 # We cannot trivally call kernel_is here, because it calls us to detect the
274 # version
136 kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git} 275 #kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
276 [ $(($KV_MAJOR * 1000 + ${KV_MINOR:-0})) -ge 2006 ] && RELEASE=${RELEASE/-pre/-git}
137 RELEASETYPE=${RELEASE//[0-9]} 277 RELEASETYPE=${RELEASE//[0-9]}
138 278
139 # Now we know that RELEASE is the -rc/-git 279 # Now we know that RELEASE is the -rc/-git
140 # and RELEASETYPE is the same but with its numerics stripped 280 # and RELEASETYPE is the same but with its numerics stripped
141 # we can work on better sorting EXTRAVERSION. 281 # we can work on better sorting EXTRAVERSION.
142 # first of all, we add the release 282 # first of all, we add the release
143 EXTRAVERSION="${RELEASE}" 283 EXTRAVERSION="${RELEASE}"
284 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
144 [[ -n ${KV_EXTRA} ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}" 285 [[ -n ${KV_EXTRA} ]] && [[ ${KV_MAJOR} -lt 3 ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
145 286
287 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
288 if [[ -n "${K_NOUSEPR}" ]]; then
289 # Don't add anything based on PR to EXTRAVERSION
290 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
146 if [[ -n ${K_PREPATCHED} ]]; then 291 elif [[ -n ${K_PREPATCHED} ]]; then
292 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
147 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}" 293 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
148 elif [[ "${ETYPE}" = "sources" ]]; then 294 elif [[ "${ETYPE}" = "sources" ]]; then
295 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
149 # For some sources we want to use the PV in the extra version 296 # For some sources we want to use the PV in the extra version
150 # This is because upstream releases with a completely different 297 # This is because upstream releases with a completely different
151 # versioning scheme. 298 # versioning scheme.
152 case ${PN/-*} in 299 case ${PN/-*} in
153 wolk) K_USEPV=1;; 300 wolk) K_USEPV=1;;
154 vserver) K_USEPV=1;; 301 vserver) K_USEPV=1;;
155 esac 302 esac
156 303
157 [[ -z ${K_NOUSENAME} ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}" 304 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
158 [[ -n ${K_USEPV} ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}" 305 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
159 [[ -n ${PR//r0} ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}" 306 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
160 fi 307 fi
308 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
161 309
162 # The only messing around which should actually effect this is for KV_EXTRA 310 # The only messing around which should actually effect this is for KV_EXTRA
163 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else 311 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
164 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION 312 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
313
165 if [[ -n ${KV_EXTRA} ]]; then 314 if [[ -n ${KV_EXTRA} ]]; then
315 if [[ -n ${KV_MINOR} ]]; then
166 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}" 316 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
167 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/patch-${CKV}.bz2 317 else
168 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.tar.bz2" 318 OKV="${KV_MAJOR}.${KV_PATCH}"
319 fi
320 KERNEL_URI="${KERNEL_BASE_URI}/patch-${CKV}.xz
321 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
169 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.bz2" 322 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
170 fi 323 fi
171 324
172 # We need to set this using OKV, but we need to set it before we do any 325 # We need to set this using OKV, but we need to set it before we do any
173 # messing around with OKV based on RELEASETYPE 326 # messing around with OKV based on RELEASETYPE
174 KV_FULL=${OKV}${EXTRAVERSION} 327 KV_FULL=${OKV}${EXTRAVERSION}
179 332
180 # -rc-git pulls can be achieved by specifying CKV 333 # -rc-git pulls can be achieved by specifying CKV
181 # for example: 334 # for example:
182 # CKV="2.6.11_rc3_pre2" 335 # CKV="2.6.11_rc3_pre2"
183 # will pull: 336 # will pull:
184 # linux-2.6.10.tar.bz2 & patch-2.6.11-rc3.bz2 & patch-2.6.11-rc3-git2.bz2 337 # linux-2.6.10.tar.xz & patch-2.6.11-rc3.xz & patch-2.6.11-rc3-git2.xz
185 338
339 if [[ ${KV_MAJOR}${KV_MINOR} -eq 26 ]]; then
340
186 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then 341 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
187 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 342 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
188 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${CKV//_/-}.bz2 343 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
189 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 344 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
190 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.bz2" 345 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
191 fi 346 fi
192 347
193 if [[ ${RELEASETYPE} == -git ]]; then 348 if [[ ${RELEASETYPE} == -git ]]; then
194 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${OKV}${RELEASE}.bz2 349 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
195 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 350 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
196 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.bz2" 351 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
197 fi 352 fi
198 353
199 if [[ ${RELEASETYPE} == -rc-git ]]; then 354 if [[ ${RELEASETYPE} == -rc-git ]]; then
200 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))" 355 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
201 KERNEL_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2 356 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz
202 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 357 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz
203 mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}/linux-${OKV}.tar.bz2" 358 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
359
204 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.bz2 ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.bz2" 360 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz"
205 fi 361 fi
362 else
363 KV_PATCH_ARR=(${KV_PATCH//\./ })
364
365 # the different majorminor versions have different patch start versions
366 OKV_DICT=(["2"]="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))" ["3"]="2.6.39" ["4"]="3.19")
367 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
368 OKV=${OKV_DICT["${KV_MAJOR}"]}
369 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
370 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
371 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
372 fi
373
374 if [[ ${RELEASETYPE} == -git ]]; then
375 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
376 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
377 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
378 fi
379
380 if [[ ${RELEASETYPE} == -rc-git ]]; then
381 OKV=${OKV_DICT["${KV_MAJOR}"]}
382 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz
383 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz
384 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
385
386 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz"
387 fi
388
389
390 fi
391
392 debug-print-kernel2-variables
206 393
207 handle_genpatches 394 handle_genpatches
208} 395}
209 396
397# Note: duplicated in linux-info.eclass
210kernel_is() { 398kernel_is() {
399 # ALL of these should be set before we can safely continue this function.
400 # some of the sources have in the past had only one set.
401 local v n=0
402 for v in OKV KV_{MAJOR,MINOR,PATCH} ; do [[ -z ${!v} ]] && n=1 ; done
211 [[ -z ${OKV} ]] && detect_version 403 [[ $n -eq 1 ]] && detect_version
404 unset v n
405
406 # Now we can continue
212 local operator test value x=0 y=0 z=0 407 local operator test value
213 408
214 case ${1} in 409 case ${1#-} in
215 lt) operator="-lt"; shift;; 410 lt) operator="-lt"; shift;;
216 gt) operator="-gt"; shift;; 411 gt) operator="-gt"; shift;;
217 le) operator="-le"; shift;; 412 le) operator="-le"; shift;;
218 ge) operator="-ge"; shift;; 413 ge) operator="-ge"; shift;;
219 eq) operator="-eq"; shift;; 414 eq) operator="-eq"; shift;;
220 *) operator="-eq";; 415 *) operator="-eq";;
221 esac 416 esac
222
223 for x in ${@}; do
224 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
225 value="${value}${x}"
226 z=$((${z} + 1))
227
228 case ${z} in
229 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
230 test="${test}${KV_MAJOR}";;
231 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
232 test="${test}${KV_MINOR}";;
233 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
234 test="${test}${KV_PATCH}";;
235 *) die "Error in kernel-2_kernel_is(): Too many parameters.";; 417 [[ $# -gt 3 ]] && die "Error in kernel-2_kernel_is(): too many parameters"
236 esac
237 done
238 418
239 [ ${test} ${operator} ${value} ] && return 0 || return 1 419 : $(( test = (KV_MAJOR << 16) + (KV_MINOR << 8) + KV_PATCH ))
420 : $(( value = (${1:-${KV_MAJOR}} << 16) + (${2:-${KV_MINOR}} << 8) + ${3:-${KV_PATCH}} ))
421 [ ${test} ${operator} ${value} ]
240} 422}
241 423
242kernel_is_2_4() { 424kernel_is_2_4() {
243 kernel_is 2 4 425 kernel_is 2 4
244} 426}
247 kernel_is 2 6 || kernel_is 2 5 429 kernel_is 2 6 || kernel_is 2 5
248} 430}
249 431
250# Capture the sources type and set DEPENDs 432# Capture the sources type and set DEPENDs
251if [[ ${ETYPE} == sources ]]; then 433if [[ ${ETYPE} == sources ]]; then
252 DEPEND="!build? ( sys-apps/sed 434 DEPEND="!build? (
435 sys-apps/sed
253 >=sys-devel/binutils-2.11.90.0.31 ) 436 >=sys-devel/binutils-2.11.90.0.31
254 doc? ( app-text/docbook-sgml-utils 437 )"
255 app-text/xmlto )" 438 RDEPEND="!build? (
256 RDEPEND="!build? ( >=sys-libs/ncurses-5.2 439 >=sys-libs/ncurses-5.2
257 sys-devel/make ) 440 sys-devel/make
258 virtual/dev-manager" 441 dev-lang/perl
259 442 sys-devel/bc
260 PROVIDE="virtual/linux-sources" 443 )"
261 kernel_is gt 2 4 && PROVIDE="${PROVIDE} virtual/alsa" 444 PDEPEND="!build? ( virtual/dev-manager )"
262 445
263 SLOT="${PVR}" 446 SLOT="${PVR}"
264 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR} linux kernel" 447 DESCRIPTION="Sources based on the Linux Kernel."
265 IUSE="symlink build doc" 448 IUSE="symlink build"
449
450 # Bug #266157, deblob for libre support
451 if [[ -z ${K_PREDEBLOBBED} ]] ; then
452 # Bug #359865, force a call to detect_version if needed
453 kernel_is ge 2 6 27 && \
454 [[ -z "${K_DEBLOB_AVAILABLE}" ]] && \
455 kernel_is le 2 6 ${DEBLOB_MAX_VERSION} && \
456 K_DEBLOB_AVAILABLE=1
457 if [[ ${K_DEBLOB_AVAILABLE} == "1" ]] ; then
458 IUSE="${IUSE} deblob"
459
460 # Reflect that kernels contain firmware blobs unless otherwise
461 # stripped
462 LICENSE="${LICENSE} !deblob? ( freedist )"
463
464 DEPEND+=" deblob? ( ${PYTHON_DEPS} )"
465
466 if [[ -n KV_MINOR ]]; then
467 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
468 else
469 DEBLOB_PV="${KV_MAJOR}.${KV_PATCH}"
470 fi
471
472 if [[ ${KV_MAJOR} -ge 3 ]]; then
473 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}"
474 fi
475
476 DEBLOB_A="deblob-${DEBLOB_PV}"
477 DEBLOB_CHECK_A="deblob-check-${DEBLOB_PV}"
478 DEBLOB_HOMEPAGE="http://www.fsfla.org/svnwiki/selibre/linux-libre/"
479 DEBLOB_URI_PATH="download/releases/LATEST-${DEBLOB_PV}.N"
480 if ! has "${EAPI:-0}" 0 1 ; then
481 DEBLOB_CHECK_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/deblob-check -> ${DEBLOB_CHECK_A}"
482 else
483 DEBLOB_CHECK_URI="mirror://gentoo/${DEBLOB_CHECK_A}"
484 fi
485 DEBLOB_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/${DEBLOB_A}"
486 HOMEPAGE="${HOMEPAGE} ${DEBLOB_HOMEPAGE}"
487
488 KERNEL_URI="${KERNEL_URI}
489 deblob? (
490 ${DEBLOB_URI}
491 ${DEBLOB_CHECK_URI}
492 )"
493 else
494 # We have no way to deblob older kernels, so just mark them as
495 # tainted with non-libre materials.
496 LICENSE="${LICENSE} freedist"
497 fi
498 fi
499
266elif [[ ${ETYPE} == headers ]]; then 500elif [[ ${ETYPE} == headers ]]; then
267 DESCRIPTION="Linux system headers" 501 DESCRIPTION="Linux system headers"
268 IUSE=""
269 502
270 if [[ ${CTARGET} = ${CHOST} ]]; then 503 # Since we should NOT honour KBUILD_OUTPUT in headers
271 DEPEND="!virtual/os-headers" 504 # lets unset it here.
272 PROVIDE="virtual/os-headers" 505 unset KBUILD_OUTPUT
506
273 SLOT="0" 507 SLOT="0"
274 else
275 SLOT="${CTARGET}"
276 fi
277else 508else
278 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\"" 509 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
279 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\"" 510 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
280fi 511fi
281 512
282# Cross-compile support functions 513# Cross-compile support functions
283#============================================================== 514#==============================================================
284kernel_header_destdir() { 515kernel_header_destdir() {
285 [[ ${CTARGET} == ${CHOST} ]] \ 516 [[ ${CTARGET} == ${CHOST} ]] \
286 && echo /usr/include \ 517 && echo /usr/include \
287 || echo /usr/${CTARGET}/include 518 || echo /usr/${CTARGET}/usr/include
288} 519}
289 520
290cross_pre_c_headers() { 521cross_pre_c_headers() {
291 [[ -z ${_E_CROSS_HEADERS_ONLY} ]] && return 1 522 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
292 [[ ${CHOST} == ${CTARGET} ]] && return 1
293 return 0
294} 523}
295 524
296env_setup_xmakeopts() { 525env_setup_xmakeopts() {
297 # Kernel ARCH != portage ARCH 526 # Kernel ARCH != portage ARCH
298 export KARCH=$(tc-arch-kernel) 527 export KARCH=$(tc-arch-kernel)
309} 538}
310 539
311# Unpack functions 540# Unpack functions
312#============================================================== 541#==============================================================
313unpack_2_4() { 542unpack_2_4() {
314 env_setup_xmakeopts
315
316 cd "${S}"
317 # this file is required for other things to build properly, 543 # this file is required for other things to build properly,
318 # so we autogenerate it 544 # so we autogenerate it
319 make -s mrproper ${xmakeopts} || die "make mrproper failed" 545 make -s mrproper ${xmakeopts} || die "make mrproper failed"
320 make -s symlinks ${xmakeopts} || die "make symlinks failed" 546 make -s symlinks ${xmakeopts} || die "make symlinks failed"
321 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed" 547 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
322 echo ">>> version.h compiled successfully." 548 echo ">>> version.h compiled successfully."
323} 549}
324 550
325unpack_2_6() { 551unpack_2_6() {
326 env_setup_xmakeopts
327
328 cd "${S}"
329 # this file is required for other things to build properly, so we 552 # this file is required for other things to build properly, so we
330 # autogenerate it ... touch .config to keep version.h build from 553 # autogenerate it ... generate a .config to keep version.h build from
331 # spitting out an annoying warning 554 # spitting out an annoying warning
332 make -s mrproper ${xmakeopts} || die "make mrproper failed" 555 make -s mrproper ${xmakeopts} 2>/dev/null \
556 || die "make mrproper failed"
557
558 # quick fix for bug #132152 which triggers when it cannot include linux
559 # headers (ie, we have not installed it yet)
560 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
333 touch .config 561 touch .config
334 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed" 562 eerror "make defconfig failed."
335 rm -f .config 563 eerror "assuming you dont have any headers installed yet and continuing"
564 epause 5
565 fi
566
567 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
568 || die "make include/linux/version.h failed"
569 rm -f .config >/dev/null
336} 570}
337 571
338universal_unpack() { 572universal_unpack() {
573 debug-print "Inside universal_unpack"
574
575 local OKV_ARRAY
576 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
577
339 cd ${WORKDIR} 578 cd "${WORKDIR}"
579 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
580 unpack linux-${KV_MAJOR}.${KV_MINOR}.tar.xz
581 else
340 unpack linux-${OKV}.tar.bz2 582 unpack linux-${OKV}.tar.xz
583 fi
584
585 if [[ -d "linux" ]]; then
586 debug-print "Moving linux to linux-${KV_FULL}"
587 mv linux linux-${KV_FULL} \
588 || die "Unable to move source tree to ${KV_FULL}."
341 if [[ "${OKV}" != "${KV_FULL}" ]]; then 589 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
590 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]] &&
591 [[ "${ETYPE}" = "sources" ]]; then
592 debug-print "moving linux-${KV_MAJOR}.${KV_MINOR} to linux-${KV_FULL} "
593 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
594 || die "Unable to move source tree to ${KV_FULL}."
595 else
596 debug-print "moving linux-${OKV} to linux-${KV_FULL} "
342 mv linux-${OKV} linux-${KV_FULL} \ 597 mv linux-${OKV} linux-${KV_FULL} \
598 || die "Unable to move source tree to ${KV_FULL}."
599 fi
600 elif [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
601 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
343 || die "Unable to move source tree to ${KV_FULL}." 602 || die "Unable to move source tree to ${KV_FULL}."
344 fi 603 fi
345 cd "${S}" 604 cd "${S}"
346 605
347 # remove all backup files 606 # remove all backup files
348 find . -iname "*~" -exec rm {} \; 2> /dev/null 607 find . -iname "*~" -exec rm {} \; 2> /dev/null
349 608
350 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
351 use ppc && \
352 sed -ie 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
353 "${S}"/arch/ppc/Makefile
354} 609}
355 610
356unpack_set_extraversion() { 611unpack_set_extraversion() {
357 cd "${S}" 612 cd "${S}"
358 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile 613 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
359 cd ${OLDPWD} 614 cd "${OLDPWD}"
360} 615}
361 616
362# Should be done after patches have been applied 617# Should be done after patches have been applied
363# Otherwise patches that modify the same area of Makefile will fail 618# Otherwise patches that modify the same area of Makefile will fail
364unpack_fix_install_path() { 619unpack_fix_install_path() {
365 cd "${S}" 620 cd "${S}"
366 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile 621 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
367} 622}
368 623
369unpack_fix_docbook() {
370 if [[ -d ${S}/Documentation/DocBook ]]; then
371 cd "${S}"/Documentation/DocBook
372 sed -ie "s:db2:docbook2:g" Makefile
373 cd ${OLDPWD}
374 fi
375}
376
377# Compile Functions 624# Compile Functions
378#============================================================== 625#==============================================================
379compile_headers() { 626compile_headers() {
380 env_setup_xmakeopts 627 env_setup_xmakeopts
381
382 # Since KBUILD_OUTPUT shouldnt be used when compiling headers, lets unset it
383 # if it exists.
384 [[ -n ${KBUILD_OUTPUT} ]] && unset KBUILD_OUTPUT
385 628
386 # if we couldnt obtain HOSTCFLAGS from the Makefile, 629 # if we couldnt obtain HOSTCFLAGS from the Makefile,
387 # then set it to something sane 630 # then set it to something sane
388 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile) 631 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
389 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer} 632 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
391 if kernel_is 2 4; then 634 if kernel_is 2 4; then
392 yes "" | make oldconfig ${xmakeopts} 635 yes "" | make oldconfig ${xmakeopts}
393 echo ">>> make oldconfig complete" 636 echo ">>> make oldconfig complete"
394 make dep ${xmakeopts} 637 make dep ${xmakeopts}
395 elif kernel_is 2 6; then 638 elif kernel_is 2 6; then
639 # 2.6.18 introduces headers_install which means we dont need any
640 # of this crap anymore :D
641 kernel_is ge 2 6 18 && return 0
642
396 # autoconf.h isnt generated unless it already exists. plus, we have 643 # autoconf.h isnt generated unless it already exists. plus, we have
397 # no guarantee that any headers are installed on the system... 644 # no guarantee that any headers are installed on the system...
398 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \ 645 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
399 || touch include/linux/autoconf.h 646 || touch include/linux/autoconf.h
400 647
401 # if K_DEFCONFIG isn't set, force to "defconfig" 648 # if K_DEFCONFIG isn't set, force to "defconfig"
402 # needed by mips 649 # needed by mips
403 if [[ -z ${K_DEFCONFIG} ]]; then 650 if [[ -z ${K_DEFCONFIG} ]]; then
651 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
652 case ${CTARGET} in
653 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
654 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
655 *) K_DEFCONFIG="defconfig";;
656 esac
657 else
404 K_DEFCONFIG="defconfig" 658 K_DEFCONFIG="defconfig"
659 fi
405 fi 660 fi
406 661
407 # if there arent any installed headers, then there also isnt an asm 662 # if there arent any installed headers, then there also isnt an asm
408 # symlink in /usr/include/, and make defconfig will fail, so we have 663 # symlink in /usr/include/, and make defconfig will fail, so we have
409 # to force an include path with $S. 664 # to force an include path with $S.
410 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/" 665 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
411 ln -sf asm-${KARCH} "${S}"/include/asm 666 ln -sf asm-${KARCH} "${S}"/include/asm
412 cross_pre_c_headers && return 0 667 cross_pre_c_headers && return 0
413 668
414 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed" 669 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
670 if compile_headers_tweak_config ; then
671 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
672 fi
415 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 673 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
416 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed" 674 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
417 fi 675 fi
418} 676}
419 677
420compile_manpages() { 678compile_headers_tweak_config() {
421 einfo "Making manpages ..." 679 # some targets can be very very picky, so let's finesse the
422 env -u ARCH make mandocs 680 # .config based upon any info we may have
681 case ${CTARGET} in
682 sh*)
683 sed -i '/CONFIG_CPU_SH/d' .config
684 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
685 return 0;;
686 esac
687
688 # no changes, so lets do nothing
689 return 1
423} 690}
424 691
425# install functions 692# install functions
426#============================================================== 693#==============================================================
427install_universal() { 694install_universal() {
428 #fix silly permissions in tarball 695 # Fix silly permissions in tarball
429 cd ${WORKDIR} 696 cd "${WORKDIR}"
430 chown -R root:root * 697 chown -R 0:0 * >& /dev/null
431 chmod -R a+r-w+X,u+w * 698 chmod -R a+r-w+X,u+w *
432 cd ${OLDPWD} 699 cd ${OLDPWD}
433} 700}
434 701
435install_headers() { 702install_headers() {
436 local ddir=$(kernel_header_destdir) 703 local ddir=$(kernel_header_destdir)
437 704
438 cd "${S}" 705 # 2.6.18 introduces headers_install which means we dont need any
706 # of this crap anymore :D
707 if kernel_is ge 2 6 18 ; then
708 env_setup_xmakeopts
709 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
710
711 # let other packages install some of these headers
712 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
713 return 0
714 fi
715
716 # Do not use "linux/*" as that can cause problems with very long
717 # $S values where the cmdline to cp is too long
718 pushd "${S}" >/dev/null
439 dodir ${ddir}/linux 719 dodir ${ddir}/linux
440 cp -ax "${S}"/include/linux/* ${D}/${ddir}/linux 720 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
441 rm -rf ${D}/${ddir}/linux/modules 721 rm -rf "${D}"/${ddir}/linux/modules
442 722
443 # Handle multilib headers and crap
444 local multi_dirs="" multi_defs=""
445 case $(tc-arch-kernel) in
446 sparc64)
447 multi_dirs="sparc sparc64"
448 multi_defs="!__arch64__ __arch64__"
449 ;;
450 x86_64)
451 multi_dirs="i386 x86_64"
452 multi_defs="__i386__ __x86_64__"
453 ;;
454 ppc64)
455 multi_dirs="ppc ppc64"
456 multi_defs="!__powerpc64__ __powerpc64__"
457 ;;
458 s390x)
459 multi_dirs="s390 s390x"
460 multi_defs="!__s390x__ __s390x__"
461 ;;
462 arm)
463 dodir ${ddir}/asm 723 dodir ${ddir}/asm
464 cp -ax "${S}"/include/asm/* "${D}"/${ddir}/asm 724 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
465 [[ ! -e ${D}/${ddir}/asm/arch ]] && ln -sf arch-ebsa285 "${D}"/${ddir}/asm/arch
466 [[ ! -e ${D}/${ddir}/asm/proc ]] && ln -sf proc-armv "${D}"/${ddir}/asm/proc
467 ;;
468 powerpc)
469 dodir ${ddir}/asm
470 cp -ax "${S}"/include/asm/* ${D}/${ddir}/asm
471 if [[ -e "${S}"/include/asm-ppc ]] ; then
472 dodir ${ddir}/asm-ppc
473 cp -ax "${S}"/include/asm-ppc/* ${D}/${ddir}/asm-ppc
474 fi
475 ;;
476 *)
477 dodir ${ddir}/asm
478 cp -ax "${S}"/include/asm/* ${D}/${ddir}/asm
479 ;;
480 esac
481 if [[ -n ${multi_dirs} ]] ; then
482 local d ml_inc=""
483 for d in ${multi_dirs} ; do
484 dodir ${ddir}/asm-${d}
485 cp -ax "${S}"/include/asm-${d}/* ${D}/${ddir}/asm-${d}/ || die "cp asm-${d} failed"
486 725
487 ml_inc="${ml_inc} ${multi_defs%% *}:${ddir}/asm-${d}"
488 multi_defs=${multi_defs#* }
489 done
490 create_ml_includes ${ddir}/asm ${ml_inc}
491 fi
492
493 if kernel_is 2 6; then 726 if kernel_is 2 6 ; then
494 dodir ${ddir}/asm-generic 727 dodir ${ddir}/asm-generic
495 cp -ax "${S}"/include/asm-generic/* ${D}/${ddir}/asm-generic 728 cp -pPR "${S}"/include/asm-generic/* "${D}"/${ddir}/asm-generic
496 fi 729 fi
497 730
498 # clean up 731 # clean up
499 find "${D}" -name '*.orig' -exec rm -f {} \; 732 find "${D}" -name '*.orig' -exec rm -f {} \;
500 733
501 cd ${OLDPWD} 734 popd >/dev/null
502} 735}
503 736
504install_sources() { 737install_sources() {
505 local doc docs file 738 local file
506 739
507 cd "${S}" 740 cd "${S}"
508 dodir /usr/src 741 dodir /usr/src
509 echo ">>> Copying sources ..." 742 echo ">>> Copying sources ..."
510 743
524 [[ -f ${FILESDIR}/../ChangeLog ]] && \ 757 [[ -f ${FILESDIR}/../ChangeLog ]] && \
525 echo "Please check the ebuild ChangeLog for more details." \ 758 echo "Please check the ebuild ChangeLog for more details." \
526 > "${S}"/patches.txt 759 > "${S}"/patches.txt
527 fi 760 fi
528 761
529 if use doc ; then
530 install_manpages
531
532 for doc in ${UNIPATCH_DOCS}; do [[ -f ${doc} ]] && docs="${docs} ${doc}"; done
533 if [[ -f ${S}/patches.txt ]]; then docs="${docs} ${S}/patches.txt"; fi
534 [[ -n ${docs} ]] && dodoc ${docs}
535 fi
536
537 mv ${WORKDIR}/linux* ${D}/usr/src 762 mv ${WORKDIR}/linux* "${D}"/usr/src
538}
539 763
540install_manpages() { 764 if [[ -n "${UNIPATCH_DOCS}" ]] ; then
541 kernel_is lt 2 5 && return 765 for i in ${UNIPATCH_DOCS}; do
542 766 dodoc "${T}"/${i}
543 local myfiles="Documentation/DocBook/Makefile" 767 done
544 kernel_is lt 2 6 12 && myfiles="scripts/makeman ${myfiles}" 768 fi
545
546 sed -ie "s#/usr/local/man#${D}/usr/share/man#g" ${myfiles}
547 ebegin "Installing manpages"
548 env -u ARCH make installmandocs
549 eend $?
550 sed -ie "s#${D}/usr/share/man#/usr/local/man#g" ${myfiles}
551} 769}
552 770
553# pkg_preinst functions 771# pkg_preinst functions
554#============================================================== 772#==============================================================
555preinst_headers() { 773preinst_headers() {
564 local MAKELINK=0 782 local MAKELINK=0
565 783
566 # if we have USE=symlink, then force K_SYMLINK=1 784 # if we have USE=symlink, then force K_SYMLINK=1
567 use symlink && K_SYMLINK=1 785 use symlink && K_SYMLINK=1
568 786
787 # if we're using a deblobbed kernel, it's not supported
788 [[ $K_DEBLOB_AVAILABLE == 1 ]] && \
789 use deblob && \
790 K_SECURITY_UNSUPPORTED=deblob
791
569 # if we are to forcably symlink, delete it if it already exists first. 792 # if we are to forcably symlink, delete it if it already exists first.
570 if [[ -n ${K_SYMLINK} ]]; then 793 if [[ ${K_SYMLINK} > 0 ]]; then
571 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux 794 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
572 MAKELINK=1 795 MAKELINK=1
573 fi 796 fi
574 797
575 # if the link doesnt exist, lets create it 798 # if the link doesnt exist, lets create it
576 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1 799 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
577 800
578 if [[ ${MAKELINK} == 1 ]]; then 801 if [[ ${MAKELINK} == 1 ]]; then
579 cd ${ROOT}usr/src 802 cd "${ROOT}"usr/src
580 ln -sf linux-${KV_FULL} linux 803 ln -sf linux-${KV_FULL} linux
581 cd ${OLDPWD} 804 cd ${OLDPWD}
582 fi 805 fi
583 806
584 # Don't forget to make directory for sysfs 807 # Don't forget to make directory for sysfs
585 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys 808 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
586 809
587 echo 810 echo
588 einfo "After installing a new kernel of any version, it is important"
589 einfo "that you have the appropriate /etc/modules.autoload.d/kernel-X.Y"
590 einfo "created (X.Y is the first 2 parts of your new kernel version)"
591 echo
592 einfo "For example, this kernel will require:"
593 einfo "/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}"
594 echo
595 einfo "If you are upgrading from a previous kernel, you may be interested" 811 elog "If you are upgrading from a previous kernel, you may be interested"
596 einfo "in the following documents:" 812 elog "in the following document:"
597 einfo " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml" 813 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
598 kernel_is_2_6 && einfo " - 2.4 to 2.6 migration guide: http://www.gentoo.org/doc/en/migration-to-2.6.xml"
599 if kernel_is ge 2 6 13; then
600 ewarn "As of 2.6.13 the support for devfs has been removed."
601 ewarn "You will be required to either manage a static /dev"
602 ewarn "or to ensure that udev is starting on boot."
603 fi
604 echo 814 echo
605 815
606 # if K_EXTRAEINFO is set then lets display it now 816 # if K_EXTRAEINFO is set then lets display it now
607 if [[ -n ${K_EXTRAEINFO} ]]; then 817 if [[ -n ${K_EXTRAEINFO} ]]; then
608 echo ${K_EXTRAEINFO} | fmt | 818 echo ${K_EXTRAEINFO} | fmt |
609 while read -s ELINE; do einfo "${ELINE}"; done 819 while read -s ELINE; do einfo "${ELINE}"; done
610 fi 820 fi
611 821
822 # if K_EXTRAELOG is set then lets display it now
823 if [[ -n ${K_EXTRAELOG} ]]; then
824 echo ${K_EXTRAELOG} | fmt |
825 while read -s ELINE; do elog "${ELINE}"; done
826 fi
827
612 # if K_EXTRAEWARN is set then lets display it now 828 # if K_EXTRAEWARN is set then lets display it now
613 if [[ -n ${K_EXTRAEWARN} ]]; then 829 if [[ -n ${K_EXTRAEWARN} ]]; then
614 echo ${K_EXTRAEWARN} | fmt | 830 echo ${K_EXTRAEWARN} | fmt |
615 while read -s ELINE; do ewarn "${ELINE}"; done 831 while read -s ELINE; do ewarn "${ELINE}"; done
616 fi 832 fi
617}
618 833
619postinst_headers() { 834 # optionally display security unsupported message
620 einfo "Kernel headers are usually only used when recompiling glibc, as such, following the installation" 835 # Start with why
621 einfo "of newer headers, it is advised that you re-merge glibc as follows:" 836 if [[ ${K_SECURITY_UNSUPPORTED} = deblob ]]; then
622 einfo "emerge glibc" 837 ewarn "Deblobbed kernels may not be up-to-date security-wise"
623 einfo "Failure to do so will cause glibc to not make use of newer features present in the updated kernel" 838 ewarn "as they depend on external scripts."
624 einfo "headers." 839 elif [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
840 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
841 fi
842 # And now the general message.
843 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
844 ewarn "This means that it is likely to be vulnerable to recent security issues."
845 ewarn "For specific information on why this kernel is unsupported, please read:"
846 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
847 fi
848
849 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
850 KV_MAJOR=$(get_version_component_range 1 ${OKV})
851 KV_MINOR=$(get_version_component_range 2 ${OKV})
852 KV_PATCH=$(get_version_component_range 3 ${OKV})
853 if [[ "$(tc-arch)" = "sparc" ]]; then
854 if [[ $(gcc-major-version) -lt 4 && $(gcc-minor-version) -lt 4 ]]; then
855 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]] ; then
856 echo
857 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
858 elog "you now need to do"
859 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
860 elog "instead of just"
861 elog " make"
862 elog "to compile the kernel. For more information please browse to"
863 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
864 echo
865 fi
866 fi
867 fi
625} 868}
626 869
627# pkg_setup functions 870# pkg_setup functions
628#============================================================== 871#==============================================================
629setup_headers() { 872setup_headers() {
655 898
656 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/" 899 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
657 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR} 900 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
658 901
659 # We're gonna need it when doing patches with a predefined patchlevel 902 # We're gonna need it when doing patches with a predefined patchlevel
660 shopt -s extglob 903 eshopts_push -s extglob
661 904
662 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers 905 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
663 # usage can be either via an env var or by params 906 # usage can be either via an env var or by params
664 # although due to the nature we pass this within this eclass 907 # although due to the nature we pass this within this eclass
665 # it shall be by param only. 908 # it shall be by param only.
666 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}" 909 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
667 UNIPATCH_LIST="${@}" 910 UNIPATCH_LIST="${@}"
668 911
669 #unpack any passed tarballs 912 #unpack any passed tarballs
670 for i in ${UNIPATCH_LIST}; do 913 for i in ${UNIPATCH_LIST}; do
671 if [ -n "$(echo ${i} | grep -e "\.tar" -e "\.tbz" -e "\.tgz")" ]; then 914 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
672 extention=${i/*./}
673 extention=${extention/:*/}
674 case ${extention} in
675 tbz2) PIPE_CMD="tar -xvjf";;
676 bz2) PIPE_CMD="tar -xvjf";;
677 tgz) PIPE_CMD="tar -xvzf";;
678 gz) PIPE_CMD="tar -xvzf";;
679 *) eerror "Unrecognized tarball compression"
680 die "Unrecognized tarball compression";;
681 esac
682
683 if [ -n "${UNIPATCH_STRICTORDER}" ]; then 915 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
684 unset z 916 unset z
685 STRICT_COUNT=$((10#${STRICT_COUNT} + 1)) 917 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
686 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++)); 918 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
687 do z="${z}0"; 919 do z="${z}0";
688 done 920 done
689 PATCH_ORDER="${z}${STRICT_COUNT}" 921 PATCH_ORDER="${z}${STRICT_COUNT}"
690 922
691 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/ 923 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
692 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR}/${PATCH_ORDER}/ 1>/dev/null 924 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
925 unpack ${i##*/}
926 popd >/dev/null
693 else 927 else
694 ${PIPE_CMD} ${i/:*/} -C ${KPATCH_DIR} 1>/dev/null 928 pushd "${KPATCH_DIR}" >/dev/null
929 unpack ${i##*/}
930 popd >/dev/null
695 fi 931 fi
696 932
697 if [ $? == 0 ]; then
698 einfo "${i/*\//} unpacked"
699 [ -n "$(echo ${i} | grep ':')" ] && echo ">>> Strict patch levels not currently supported for tarballed patchsets" 933 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
700 else
701 eerror "Failed to unpack ${i/:*/}"
702 die "unable to unpack patch tarball"
703 fi
704 else 934 else
705 extention=${i/*./} 935 extention=${i/*./}
706 extention=${extention/:*/} 936 extention=${extention/:*/}
707 PIPE_CMD="" 937 PIPE_CMD=""
708 case ${extention} in 938 case ${extention} in
939 xz) PIPE_CMD="xz -dc";;
940 lzma) PIPE_CMD="lzma -dc";;
709 bz2) PIPE_CMD="bzip2 -dc";; 941 bz2) PIPE_CMD="bzip2 -dc";;
710 patch) PIPE_CMD="cat";; 942 patch*) PIPE_CMD="cat";;
711 diff) PIPE_CMD="cat";; 943 diff) PIPE_CMD="cat";;
712 gz|Z|z) PIPE_CMD="gzip -dc";; 944 gz|Z|z) PIPE_CMD="gzip -dc";;
713 ZIP|zip) PIPE_CMD="unzip -p";; 945 ZIP|zip) PIPE_CMD="unzip -p";;
714 *) UNIPATCH_DROP="${UNIPATCH_DROP} ${i/:*/}";; 946 *) UNIPATCH_DROP="${UNIPATCH_DROP} ${i/:*/}";;
715 esac 947 esac
736 do z="${z}0"; 968 do z="${z}0";
737 done 969 done
738 PATCH_ORDER="${z}${STRICT_COUNT}" 970 PATCH_ORDER="${z}${STRICT_COUNT}"
739 971
740 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/ 972 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
741 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) 973 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
742 else 974 else
743 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) 975 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
976 fi
977 fi
978 fi
979
980 # If experimental was not chosen by the user, drop experimental patches not in K_EXP_GENPATCHES_LIST.
981 if [[ "${i}" == *"genpatches-"*".experimental."* && -n ${K_EXP_GENPATCHES_PULL} ]] ; then
982 if [[ -z ${K_EXP_GENPATCHES_NOUSE} ]] && use experimental; then
983 continue
984 fi
985
986 local j
987 for j in ${KPATCH_DIR}/*/50*_*.patch*; do
988 for k in ${K_EXP_GENPATCHES_LIST} ; do
989 [[ "$(basename ${j})" == ${k}* ]] && continue 2
990 done
991 UNIPATCH_DROP+=" $(basename ${j})"
992 done
993 else
994 UNIPATCH_LIST_GENPATCHES+=" ${DISTDIR}/${tarball}"
995 debug-print "genpatches tarball: $tarball"
996
997 # check gcc version < 4.9.X uses patch 5000 and = 4.9.X uses patch 5010
998 if [[ $(gcc-major-version) -eq 4 ]] && [[ $(gcc-minor-version) -ne 9 ]]; then
999 # drop 5000_enable-additional-cpu-optimizations-for-gcc-4.9.patch
1000 if [[ $UNIPATCH_DROP != *"5010_enable-additional-cpu-optimizations-for-gcc-4.9.patch"* ]]; then
1001 UNIPATCH_DROP+=" 5010_enable-additional-cpu-optimizations-for-gcc-4.9.patch"
1002 fi
1003 else
1004 if [[ $UNIPATCH_DROP != *"5000_enable-additional-cpu-optimizations-for-gcc.patch"* ]]; then
1005 #drop 5000_enable-additional-cpu-optimizations-for-gcc.patch
1006 UNIPATCH_DROP+=" 5000_enable-additional-cpu-optimizations-for-gcc.patch"
744 fi 1007 fi
745 fi 1008 fi
746 fi 1009 fi
747 done 1010 done
748 1011
750 x=${KPATCH_DIR} 1013 x=${KPATCH_DIR}
751 KPATCH_DIR="" 1014 KPATCH_DIR=""
752 for i in $(find ${x} -type d | sort -n); do 1015 for i in $(find ${x} -type d | sort -n); do
753 KPATCH_DIR="${KPATCH_DIR} ${i}" 1016 KPATCH_DIR="${KPATCH_DIR} ${i}"
754 done 1017 done
1018
1019 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
1020 # bug #272676
1021 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
1022 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
1023 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
1024 echo
1025 ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
1026 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
1027 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
1028 echo
1029 fi
1030 fi
755 1031
756 #so now lets get rid of the patchno's we want to exclude 1032 #so now lets get rid of the patchno's we want to exclude
757 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}" 1033 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
758 for i in ${UNIPATCH_DROP}; do 1034 for i in ${UNIPATCH_DROP}; do
759 ebegin "Excluding Patch #${i}" 1035 ebegin "Excluding Patch #${i}"
770 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/} 1046 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/}
771 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/} 1047 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/}
772 1048
773 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi 1049 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
774 1050
1051 ####################################################################
1052 # IMPORTANT: This is temporary code to support Linux git 3.15_rc1! #
1053 # #
1054 # The patch contains a removal of a symlink, followed by addition #
1055 # of a file with the same name as the symlink in the same #
1056 # location; this causes the dry-run to fail, filed bug #507656. #
1057 # #
1058 # https://bugs.gentoo.org/show_bug.cgi?id=507656 #
1059 ####################################################################
1060 if [[ ${PN} == "git-sources" ]] ; then
1061 if [[ ${KV_MAJOR}${KV_PATCH} -ge 315 && ${RELEASETYPE} == -rc ]] ; then
775 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)" 1062 ebegin "Applying ${i/*\//} (-p1)"
776 while [ ${PATCH_DEPTH} -lt 5 ]; do
777 echo "Attempting Dry-run:" >> ${STDERR_T}
778 echo "cmd: patch -p${PATCH_DEPTH} --dry-run -f < ${i}" >> ${STDERR_T}
779 echo "=======================================================" >> ${STDERR_T}
780 if [ $(patch -p${PATCH_DEPTH} --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
781 echo "Attempting patch:" > ${STDERR_T}
782 echo "cmd: patch -p${PATCH_DEPTH} -f < ${i}" >> ${STDERR_T}
783 echo "=======================================================" >> ${STDERR_T}
784 if [ $(patch -p${PATCH_DEPTH} -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then 1063 if [ $(patch -p1 --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
785 eend 0 1064 eend 0
786 rm ${STDERR_T} 1065 rm ${STDERR_T}
787 break 1066 break
788 else 1067 else
789 eend 1 1068 eend 1
790 eerror "Failed to apply patch ${i/*\//}" 1069 eerror "Failed to apply patch ${i/*\//}"
791 eerror "Please attach ${STDERR_T} to any bug you may post." 1070 eerror "Please attach ${STDERR_T} to any bug you may post."
1071 eshopts_pop
1072 die "Failed to apply ${i/*\//} on patch depth 1."
1073 fi
1074 fi
1075 fi
1076 ####################################################################
1077
1078 while [ ${PATCH_DEPTH} -lt 5 ]; do
1079 echo "Attempting Dry-run:" >> ${STDERR_T}
1080 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
1081 echo "=======================================================" >> ${STDERR_T}
1082 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
1083 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH})"
1084 echo "Attempting patch:" > ${STDERR_T}
1085 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
1086 echo "=======================================================" >> ${STDERR_T}
1087 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
1088 eend 0
1089 rm ${STDERR_T}
1090 break
1091 else
1092 eend 1
792 die "Failed to apply ${i/*\//}" 1093 eerror "Failed to apply patch ${i/*\//}"
1094 eerror "Please attach ${STDERR_T} to any bug you may post."
1095 eshopts_pop
1096 die "Failed to apply ${i/*\//} on patch depth ${PATCH_DEPTH}."
793 fi 1097 fi
794 else 1098 else
795 PATCH_DEPTH=$((${PATCH_DEPTH} + 1)) 1099 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
796 fi 1100 fi
797 done 1101 done
798 if [ ${PATCH_DEPTH} -eq 5 ]; then 1102 if [ ${PATCH_DEPTH} -eq 5 ]; then
799 eend 1 1103 eerror "Failed to dry-run patch ${i/*\//}"
800 eerror "Please attach ${STDERR_T} to any bug you may post." 1104 eerror "Please attach ${STDERR_T} to any bug you may post."
801 die "Unable to dry-run patch." 1105 eshopts_pop
1106 die "Unable to dry-run patch on any patch depth lower than 5."
802 fi 1107 fi
803 done 1108 done
804 done 1109 done
805 1110
806 # This is a quick, and kind of nasty hack to deal with UNIPATCH_DOCS which 1111 # When genpatches is used, we want to install 0000_README which documents
807 # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite, 1112 # the patches that were used; such that the user can see them, bug #301478.
808 # which is why I'm not taking too much time over this. 1113 if [[ ! -z ${K_WANT_GENPATCHES} ]] ; then
1114 UNIPATCH_DOCS="${UNIPATCH_DOCS} 0000_README"
1115 fi
1116
1117 # When files listed in UNIPATCH_DOCS are found in KPATCH_DIR's, we copy it
1118 # to the temporary directory and remember them in UNIPATCH_DOCS to install
1119 # them during the install phase.
809 local tmp 1120 local tmp
1121 for x in ${KPATCH_DIR}; do
810 for i in ${UNIPATCH_DOCS}; do 1122 for i in ${UNIPATCH_DOCS}; do
1123 if [[ -f "${x}/${i}" ]] ; then
811 tmp="${tmp} ${i//*\/}" 1124 tmp="${tmp} ${i}"
812 cp -f ${i} ${T}/ 1125 cp -f "${x}/${i}" "${T}"/
1126 fi
1127 done
813 done 1128 done
814 UNIPATCH_DOCS="${tmp}" 1129 UNIPATCH_DOCS="${tmp}"
815 1130
816 # clean up KPATCH_DIR's - fixes bug #53610 1131 # clean up KPATCH_DIR's - fixes bug #53610
817 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done 1132 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
818 1133
819 LC_ALL="${myLC_ALL}" 1134 LC_ALL="${myLC_ALL}"
820 LANG="${myLANG}" 1135 LANG="${myLANG}"
1136 eshopts_pop
821} 1137}
822 1138
823# getfilevar accepts 2 vars as follows: 1139# getfilevar accepts 2 vars as follows:
824# getfilevar <VARIABLE> <CONFIGFILE> 1140# getfilevar <VARIABLE> <CONFIGFILE>
825# pulled from linux-info 1141# pulled from linux-info
874 done 1190 done
875 fi 1191 fi
876 done 1192 done
877} 1193}
878 1194
879# sparc nastiness
880#==============================================================
881# This script generates the files in /usr/include/asm for sparc systems
882# during installation of sys-kernel/linux-headers.
883# Will no longer be needed when full 64 bit support is used on sparc64
884# systems.
885#
886# Shamefully ripped from Debian
887# ----------------------------------------------------------------------
888
889# Idea borrowed from RedHat's kernel package
890
891# This is gonna get replaced by something in multilib.eclass soon...
892# --eradicator
893generate_sparc_asm() {
894 local name
895
896 cd $1 || die
897 mkdir asm
898
899 for h in `( ls asm-sparc; ls asm-sparc64 ) | grep '\.h$' | sort -u`; do
900 name="$(echo $h | tr a-z. A-Z_)"
901 # common header
902 echo "/* All asm/ files are generated and point to the corresponding
903 * file in asm-sparc or asm-sparc64.
904 */
905
906#ifndef __SPARCSTUB__${name}__
907#define __SPARCSTUB__${name}__
908" > asm/${h}
909
910 # common for sparc and sparc64
911 if [ -f asm-sparc/$h -a -f asm-sparc64/$h ]; then
912 echo "#ifdef __arch64__
913#include <asm-sparc64/$h>
914#else
915#include <asm-sparc/$h>
916#endif
917" >> asm/${h}
918
919 # sparc only
920 elif [ -f asm-sparc/$h ]; then
921echo "#ifndef __arch64__
922#include <asm-sparc/$h>
923#endif
924" >> asm/${h}
925
926 # sparc64 only
927 else
928echo "#ifdef __arch64__
929#include <asm-sparc64/$h>
930#endif
931" >> asm/${h}
932 fi
933
934 # common footer
935 echo "#endif /* !__SPARCSTUB__${name}__ */" >> asm/${h}
936 done
937 return 0
938}
939
940headers___fix() { 1195headers___fix() {
941 # Voodoo to partially fix broken upstream headers. 1196 # Voodoo to partially fix broken upstream headers.
942 # Issues with this function should go to plasmaroo. 1197 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
943 sed -i \ 1198 sed -i \
944 -e "s/\([ "$'\t'"]\)\(u\|s\)\(8\|16\|32\|64\)\([ "$'\t'"]\)/\1__\2\3\4/g;" \ 1199 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
945 -e 's/ \(u\|s\)\(8\|16\|32\|64\)$/ __\1\2/g' \ 1200 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
946 -e 's/\([(, ]\)\(u\|s\)64\([, )]\)/\1__\264\3/g' \ 1201 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
947 -e "s/^\(u\|s\)\(8\|16\|32\|64\)\([ "$'\t'"]\)/__\1\2\3/g;" \ 1202 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
948 -e "s/ inline / __inline__ /g" \ 1203 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
949 "$@" 1204 "$@"
950} 1205}
951 1206
952# common functions 1207# common functions
953#============================================================== 1208#==============================================================
954kernel-2_src_unpack() { 1209kernel-2_src_unpack() {
955 universal_unpack 1210 universal_unpack
1211 debug-print "Doing unipatch"
956 1212
957 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \ 1213 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
958 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}" 1214 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
1215
1216 debug-print "Doing premake"
959 1217
960 # allow ebuilds to massage the source tree after patching but before 1218 # allow ebuilds to massage the source tree after patching but before
961 # we run misc `make` functions below 1219 # we run misc `make` functions below
962 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake 1220 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
963 1221
1222 debug-print "Doing epatch_user"
1223 epatch_user
1224
1225 debug-print "Doing unpack_set_extraversion"
1226
964 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion 1227 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
965 unpack_fix_docbook
966 unpack_fix_install_path 1228 unpack_fix_install_path
967 1229
1230 # Setup xmakeopts and cd into sourcetree.
1231 env_setup_xmakeopts
1232 cd "${S}"
1233
1234 # We dont need a version.h for anything other than headers
1235 # at least, I should hope we dont. If this causes problems
1236 # take out the if/fi block and inform me please.
1237 # unpack_2_6 should now be 2.6.17 safe anyways
1238 if [[ ${ETYPE} == headers ]]; then
968 kernel_is 2 4 && unpack_2_4 1239 kernel_is 2 4 && unpack_2_4
969 kernel_is 2 6 && unpack_2_6 1240 kernel_is 2 6 && unpack_2_6
1241 fi
1242
1243 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1244 cp "${DISTDIR}/${DEBLOB_A}" "${T}" || die "cp ${DEBLOB_A} failed"
1245 cp "${DISTDIR}/${DEBLOB_CHECK_A}" "${T}/deblob-check" || die "cp ${DEBLOB_CHECK_A} failed"
1246 chmod +x "${T}/${DEBLOB_A}" "${T}/deblob-check" || die "chmod deblob scripts failed"
1247 fi
1248
1249 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
1250 # only do this for kernel < 2.6.27 since this file does not exist in later
1251 # kernels
1252 if [[ -n ${KV_MINOR} && ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]] ; then
1253 sed -i \
1254 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
1255 "${S}"/arch/ppc/Makefile
1256 else
1257 sed -i \
1258 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
1259 "${S}"/arch/powerpc/Makefile
1260 fi
970} 1261}
971 1262
972kernel-2_src_compile() { 1263kernel-2_src_compile() {
973 cd "${S}" 1264 cd "${S}"
974 [[ ${ETYPE} == headers ]] && compile_headers 1265 [[ ${ETYPE} == headers ]] && compile_headers
975 [[ ${ETYPE} == sources ]] && \ 1266
976 use doc && compile_manpages 1267 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1268 echo ">>> Running deblob script ..."
1269 python_setup
1270 sh "${T}/${DEBLOB_A}" --force || die "Deblob script failed to run!!!"
1271 fi
977} 1272}
1273
1274# if you leave it to the default src_test, it will run make to
1275# find whether test/check targets are present; since "make test"
1276# actually produces a few support files, they are installed even
1277# though the package is binchecks-restricted.
1278#
1279# Avoid this altogether by making the function moot.
1280kernel-2_src_test() { :; }
978 1281
979kernel-2_pkg_preinst() { 1282kernel-2_pkg_preinst() {
980 [[ ${ETYPE} == headers ]] && preinst_headers 1283 [[ ${ETYPE} == headers ]] && preinst_headers
981} 1284}
982 1285
985 [[ ${ETYPE} == headers ]] && install_headers 1288 [[ ${ETYPE} == headers ]] && install_headers
986 [[ ${ETYPE} == sources ]] && install_sources 1289 [[ ${ETYPE} == sources ]] && install_sources
987} 1290}
988 1291
989kernel-2_pkg_postinst() { 1292kernel-2_pkg_postinst() {
990 [[ ${ETYPE} == headers ]] && postinst_headers
991 [[ ${ETYPE} == sources ]] && postinst_sources 1293 [[ ${ETYPE} == sources ]] && postinst_sources
992} 1294}
993 1295
994kernel-2_pkg_setup() { 1296kernel-2_pkg_setup() {
1297 if kernel_is 2 4; then
1298 if [[ $(gcc-major-version) -ge 4 ]] ; then
1299 echo
1300 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1301 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1302 ewarn "newer kernel that supports gcc-4."
1303 echo
1304 ewarn "Also be aware that bugreports about gcc-4 not working"
1305 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1306 echo
1307 epause 10
1308 fi
1309 fi
1310
1311 ABI="${KERNEL_ABI}"
995 [[ ${ETYPE} == headers ]] && setup_headers 1312 [[ ${ETYPE} == headers ]] && setup_headers
996 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..." 1313 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
997} 1314}
1315
1316kernel-2_pkg_postrm() {
1317 # This warning only makes sense for kernel sources.
1318 [[ ${ETYPE} == headers ]] && return 0
1319
1320 # If there isn't anything left behind, then don't complain.
1321 [[ -e ${ROOT}usr/src/linux-${KV_FULL} ]] || return 0
1322 echo
1323 ewarn "Note: Even though you have successfully unmerged "
1324 ewarn "your kernel package, directories in kernel source location: "
1325 ewarn "${ROOT}usr/src/linux-${KV_FULL}"
1326 ewarn "with modified files will remain behind. By design, package managers"
1327 ewarn "will not remove these modified files and the directories they reside in."
1328 echo
1329}

Legend:
Removed from v.1.159  
changed lines
  Added in v.1.301

  ViewVC Help
Powered by ViewVC 1.1.20